Imports System.Runtime.InteropServices


''----------------------------------------------------------------------
Public Structure sI2C_TRANS     '<StructLayout(LayoutKind.Sequential)>
    Dim byTransType As Byte
    Dim bySlvDevAddr As Byte
    Dim wMemoryAddr As UInt16
    Dim wCount As UInt16
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=256)> Public Data() As Byte 'unmanaged array
End Structure

''----------------------------------------------------------------------
'I2C transaction types
Public Enum I2C_TRANS_TYPE
    'supported transaction types
    I2C_TRANS_NOADR         'read or write with no address cycle
    I2C_TRANS_8ADR          'read or write with 8 bit address cycle
    I2C_TRANS_16ADR         'read or write with 16 bit address cycle
    I2C_TRANS_NOADR_NS      'read or write with no address cycle, stop signaling suppressed
End Enum

''----------------------------------------------------------------------
Public Class clUSBI2C


    <DllImport("usbi2cio.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DAPI_GetDllVersion() As Short
    End Function

    <DllImport("usbi2cio.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DAPI_OpenDeviceInstance(ByVal DevName As String, ByVal DevInstance As Byte) As IntPtr
    End Function

    <DllImport("usbi2cio.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DAPI_ConfigIoPorts(ByVal Handle As IntPtr, ByVal IOPattern As UInt32) As Boolean
    End Function

    <DllImport("usbi2cio.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DAPI_WriteIoPorts(ByVal Handle As IntPtr, ByVal IOData As UInt32, ByVal IOMask As UInt32) As Boolean
    End Function

    <DllImport("usbi2cio.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DAPI_CloseDeviceInstance(ByVal Handle As IntPtr) As Boolean
    End Function

    <DllImport("usbi2cio.dll", CharSet:=CharSet.Auto)> _
    Public Shared Function DAPI_WriteI2c(ByVal Handle As IntPtr, ByRef I2C_Trans As sI2C_TRANS) As Int32
    End Function



End Class


